uniform float offset;
uniform sampler2D T0;
uniform float garblefactor;
varying vec2 screenPosition;
uniform float fuglyness;
// varying vec3 color;

void main(void) 
{
  vec3 rayStart = vec3(screenPosition, 0.0);
  vec2 moddedScreenPosition = vec2( cos(screenPosition.x * 3.1415 * 4.0),  sin(screenPosition.y * 3.1415 * 4.0));

  moddedScreenPosition = screenPosition;


  //                                    float z = 1.0/cos(length(screenPosition)*10.0);
                                    
  float fuglyfactor = 1.0+fuglyness*sin( atan( moddedScreenPosition.x , moddedScreenPosition.y ) * 3.0 );
  vec3 rayDirection = normalize( vec3(moddedScreenPosition, fuglyfactor));
  vec3 accumColor = vec3(0.0 ,0.0, 0.0);

                                    
  rayStart.z += offset;
                                    
  float r = 1.0;

  //gl_FragColor.rgb = vec3(0,0,0);
  for (int i = 0; i <3;++i)
    {

                                    
      float a = rayDirection.x*rayDirection.x + rayDirection.y*rayDirection.y;
      float b = 2.0 * (rayStart.x*rayDirection.x + rayStart.y*rayDirection.y);
      float c = rayStart.x*rayStart.x + rayStart.y*rayStart.y - r*r;

      float d = b*b - 4.0*a*c;


      {
        float maxt = (-b + sqrt(d)) / (2.0*a);

        if (maxt >= 0.0) {

          vec3 intersection = rayStart + rayDirection * maxt;

                                          

          //vec2 texCoord = vec2(intersection.z * 0.01 + offset * 0.01, intersection.y + offset * 0.01);
          vec2 texCoord = vec2(intersection.z*.1, offset*.061 + cos(offset*.2+intersection.z*.1) +  atan(intersection.y, intersection.x) / 3.14115926535);

          float factor = (1.0-maxt*.04);

          if (factor > .4) {

                                          
            vec3 texel =texture2D(T0, texCoord).xyz;
            float a = cos(offset * .3892 + 4.0*texel.r) * garblefactor;
            rayStart.x *= (1.0 + a);
            rayStart.y *= (1.0 + a);


                                          
            accumColor += texel * .4 * (1.0-maxt*.04);
          }

        }
                                        
      }

    }
  gl_FragColor.rgb = accumColor;
}
                            
